/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
******************************************************************************
**                                                                            
**        Y     Y   OOOO    OOOO   DDDDD     AA
**         Y   Y   O    O  O    O  D    D   A  A
**          Y Y    O    O  O    O  D    D  A    A 
**           Y     O    O  O    O  D    D  AAAAAA
**           Y     O    O  O    O  D    D  A    A
**           Y      OOOO    OOOO   DDDDD   A    A
**
******************************************************************************
******************************************************************************/
/*****************************************************************************
*
*  MODULE :             Multiple definition
*  SCOPE :              Multiple definition
*  FILE :               define.h
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      August 1, 1993
*  COPYRIGHTS :        (C) E. Abecassis, 1993
*  HISTORY :
*
******************************************************************************/

#ifndef __define_H
#define __define_H

/* IMPORTS *******************************************************************/

/*****************************************************************************/

#ifndef TRUE 
#define TRUE 1
#endif

#ifndef FALSE 
#define FALSE 0
#endif

// classId value for a free bloc
#define FREEBLK 0

// Value for object without type
#define UNTYPED 1

// First valid value for classId
#define FIRST_TYPE 2

// directory entry for a free object
#define FREE_SLOT SLOT_IN_PG

// directory entry for a deleted object
#define DEL_SLOT SLOT_IN_PG+1

// Define time to wait between to lock demand
#define LOCK_TIME_REDO 1

// Define maximum number of bufferized pages during checkpoint
#define YOO_MAX_BUFF_PAGE 256

// Define good result
#define OK 1

// Define bad result
#define KO 0

// Define forbidden upgrade result
#define FORBID_UPGRADE -1

// Keyword for single user mode
#define MONOUSER "mono"


#endif
