#ifndef oo_base_HXX
#define oo_base_HXX

#ifndef oobd_HXX
#include "oobd.hxx"
#endif

#ifndef oo_type_HXX
#include "oo_type.hxx"
#endif

#ifndef oo_objet_HXX
#include "oo_objet.hxx"
#endif


class BD_ObjNom {
  public :

  StringX nom ;
  OID     objet ;

  BD_ObjNom(StringX n, Ref<BD_Objet> obj) : nom(n), objet(obj.getOid()) {} ;
} ;


class BD_Base {
  private :

  SharedSet<BD_Objet> objets ;
  DictX<BD_Type, int, yoo_index(BD_Type::typeIdent)> dicoTypes ;
  SharedDict<BD_ObjNom, StringX, yoo_index(BD_ObjNom::nom)> dicoNom ;
  SharedDict<BD_ObjNom, OID, yoo_index(BD_ObjNom::objet)>   dicoObj ;

  static SharedSetIterator<BD_Objet>* iter ;
  static Ref<BD_Objet> objetCourant ;

  public :

  // Reset l'iterateur courant lors d'un commit ou d'un abort
  static void reset() { 
    if (iter != NULL) delete iter; 
    iter = NULL ;
  } 

  // Renvoie 0 en erreur, 1 si OK
  int ajouterNom(BD_Objet* obj, char* nom) ;

  // Renvoie NULL en erreur   
  BD_Objet* ajouterObjet() ;

  // Renvoie 0 en erreur, 1 si OK
  int ajouterRelation(BD_Objet* obj1, BD_Objet* obj2, int typeRel) ;

  // Renvoie 0 en erreur, 1 si OK
  int ajouterDansType(BD_Objet* obj, int typeIdent) ;

  // Renvoie le type d'identifiant typ
  BD_Type* lireType(int typ) ;

  // Renvoie 0 en erreur, 1 si OK
  int lireNom(BD_Objet* obj, char* nom) ;

  // Parcours des objets de la BD avec iterateur
  BD_Objet* parcourirBD(BD_CodeParc) ;

  // Renvoie l'objet de nom 'nom'. NULL si inexistant.
  BD_Objet* chercherObjet(char* nom) ;

  // Suppression du nom de l'objet
  int supprimerNom(BD_Objet*) ;

  // Suppression de l'objet dans la base
  int supprimeObjet(BD_Objet*) ;

  // Suppression d'une relation bidirectionnelle
  int supprimerRelation(BD_Objet* o1,BD_Objet* o2, int typerel, BD_CodeSupp) ;

} ;

#endif



