/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#ifdef __GNUG__
#pragma interface
#endif

// Iterator for a list of values.
class IterListVal<char*> : public IterList {
  public :

  IterListVal(List& l, int b=0, int e=-1) : IterList(l, b,e) {}

  char* get() { return (char*)this->IterList::get() ; }

  void remove() { delete (char*)this->IterList::remove() ; }

  void insert(char* el) { this->IterList::insert(strdup(el)) ; }

  void insertRef(char* el) { this->IterList::insert(el) ; }
} ;


class ListVal<char*> : public List {
  public :
  
  ListVal() {};

  ListVal(ListVal<char*>& l, __YOOC_LIST_CTOR) {
    this->capture(l) ;
  }
  
  ListVal(const ListVal<char*>& l) {    
    IterListVal<char*> iterDst(*this) ;
    IterListVal<char*> iterSrc(*(List*)&l) ;
    for (; iterSrc.more(); iterSrc.next()) {
      iterDst.insert(iterSrc.get()) ;
    }
  }

  void clear() { while (size) { delete (char*)this->List::remove(0) ; } } ;

  ~ListVal() { this->clear() ; } ;
  
  void insertVal(char* elem, int i) { 
    this->List::insert(strdup(elem), i) ; 
  }

  void insertRef(char* elem, int i) { 
    this->List::insert(elem, i) ; 
  }

  void insert(char* elem, int i) { 
    this->List::insert(strdup(elem), i) ; 
  }

  void remove(int i) { delete (char*)this->List::remove(i) ; }

  char* get(int i) { return (char*)this->List::get(i)->elem ; } 

  char* operator[](int i) { return get(i) ; }

  ListVal<char*>& operator+=(char* el) {
    this->insert(el, 0) ; return *this ;
  }

} ;


SvcSocket& operator>>(SvcSocket& s, ListVal<char*>& l) ;
