/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
*
*  MODULE :             Pattern matching template
*  SCOPE :              Implements reverse pattern matching
*  FILE :               pattern.hxx
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      July 1, 1994
*  COPYRIGHTS :        (C) APIC Systeme 1994
*  HISTORY :
*
******************************************************************************/

#ifdef __GNUG__
#pragma interface
#endif
#ifndef __pattern_HXX
#define __pattern_HXX

/* IMPORTS *******************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
//#include <unistd.h>
#include <iostream.h>

/*****************************************************************************/

#define PATM_JOKER '*'
#define PATM_MAX_CAR 256
#define ACTION_INVALIDE (-1)
#define TRANSITION_INVALIDE (-1)
#define TRANSITION_VALIDE (0)

class PATM_Etat {
  private :
  char _transV1 ;
  short _transO1 ;
  short* _transition ;
  char _termV1 ;
  short _termO1 ;
  short* _terminal ;  
  
  public :
  PATM_Etat() : _transV1(0), _transO1(-1), _transition(NULL),_termV1(0),
  _termO1(-1), _terminal(NULL) {}
  int terminal(char) ;
  int transition(char) ;
  int joker() {
    return ( (_transV1 == PATM_JOKER) ||
	     ( (_transition != NULL) && (_transition[PATM_JOKER] != -1) ) ) ;
  }
  int insererTransition(char cle, int offs) ;
  int insererTransitionUnique(char cle, int offs) ;
  int insererTransitionMultiple(char cle, int offs) ;
  void insererTerminal(char cle, int action) ;
  void insererTerminalUnique(char cle, int action) ;
  void insererTerminalMultiple(char cle, int action) ;
  void dump(int n, int& opt_first, int& opt_next ,char* opt_text) ;
} ;

class PATM_Contexte {

  private :
  char*   _cle ;
  short _sauveEtat ;
  short _sauveCaractere ;
  short _caractere ;
  short _fin ;
  short _fcnt ;

  public :
  u_short etat ;
  PATM_Contexte(char* cle) : _cle(cle), _sauveEtat(-1), _sauveCaractere(-1),
  _caractere(0), _fcnt(-1), etat(0) { _fin = strlen(cle) - 1 ; }
  int fonction() { return _fcnt ; }
  int deplacer(PATM_Etat*) ;
} ;

#include "pattern_tmpl.hxx"

#endif
