/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#include <sys/time.h>
#include "poll.h"

int poll(pollfd* pfd, int size, int tout) 
{
  struct timeval tv ;
  tv.tv_sec = tout / 1000 ;
  tv.tv_usec = (tout - tv.tv_sec*1000) * 1000 ;

  fd_set readfd ;
  FD_ZERO(&readfd) ;
  fd_set writefd ;
  FD_ZERO(&writefd) ;

  for (int i = 0; i < size; i++) {
    if (pfd[i].fd != -1) {
      if (pfd[i].events & POLLIN) {
	FD_SET(pfd[i].fd, &readfd) ;
      }
      if (pfd[i].events & POLLOUT) {
	FD_SET(pfd[i].fd, &writefd) ;
      }
    }
  }

  int res = select(size, &readfd, &writefd, NULL, &tv) ; 

  if (res <= 0) return res ;

  for (i = 0; i < size; i++) {
    if (pfd[i].fd != -1) {
      if ((pfd[i].events & POLLIN) && (FD_ISSET(pfd[i].fd, &readfd))) {
	pfd[i].revents == 1 ;
      }
      if ((pfd[i].events & POLLOUT) && (FD_ISSET(pfd[i].fd, &writefd))) {
	pfd[i].revents == 1 ;
      }
    }
  }
  return res ;
}

