/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#define SIZEOF_PAGE 8192

class OID {
  public :
  int numobj ;

  friend SvcSocket& operator<<(SvcSocket& s, OID& oid) { 
    s << oid.numobj ; return s ; 
  }
  friend SvcSocket& operator>>(SvcSocket& s, OID& oid) { 
    s >> oid.numobj ; return s ;
  }
} ;

class Page {
  public :
  u_char tab[SIZEOF_PAGE] ;

  friend SvcSocket& operator<<(SvcSocket& s, Page& p) { 
    s.send((char*)p.tab, SIZEOF_PAGE) ; return s ;
  }
  friend SvcSocket& operator>>(SvcSocket& s, Page& p) { 
    s.recv((char*)p.tab, SIZEOF_PAGE) ; return s ;
  }
} ;


