/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#include <stdio.h>

#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>

struct timeval Tbegin;
struct timeval Tend;
struct timeval tt ;

void timeBegin()
{
  gettimeofday(&Tbegin, NULL);
}

void timeEnd()
{
  gettimeofday(&Tend, NULL);
}

double timeDiff()
{
  double res = (Tend.tv_sec - Tbegin.tv_sec) ;
  res += ((float)(Tend.tv_usec)/1000000) - ((float)(Tbegin.tv_usec)/1000000) ;
  return res ;
}

#include <iostream.h>

#include "tableofbits.hxx"

int main()
{
  TableOfBits table(4096*64);

  table.zero() ;
  table.set(0, 4096*64) ;

  char command = 'c' ;
  int deb, nbe, step ;

  while (command != 'q') {
    cout << "\n\nCommand ? " ;
    cin >> command ;
    switch (command) {
      case 's' :
	cout << "\nSet" ;
	cout << "\nPosition ? " ;
        cin >> deb ;
	cout << "\nCombien d'element ? " ;
        cin >> nbe ;
	table.set(deb, nbe) ;
        break ;
      case 'c' :
	cout << "\nClear" ;
	cout << "\nPosition ? " ;
        cin >> deb ;
	cout << "\nCombien d'element ? " ;
        cin >> nbe ;
	table.clear(deb, nbe) ;
        break ;
      case 't' :
	cout << "\nTest clear" ;
	cout << "\nPosition ? " ;
        cin >> deb ;
	cout << "\nCombien d'element ? " ;
        cin >> nbe ;
	cout << "\nResultat : " << table.isclear(deb, nbe) ;
        break ;
    case 'l' :
	cout << "\nLook" ;
	cout << "\nPosition ? " ;
        cin >> deb ;
	cout << "\nCombien d'element ? " ;
        cin >> nbe ;
	cout << "\nCombien de tour ? " ;
	cin >> step ;
	int res ;
	timeBegin() ;
	for (int i = 0; i < step; i++) {
	  res = table.look(deb, nbe) ;
	}
	timeEnd() ;
	cout << "\nResultat : " << res << endl ;
	printf("\nTemps Ecoule : %f", timeDiff()) ;
        break ;
      default : 
	cout << "Choix impossible\n" ;
    }
  }         
}
